/* eslint-disable react/no-render-return-value */

/* eslint-disable react/no-find-dom-node */
import React from 'react';
import ReactDOM from 'react-dom';
import TestUtils from 'react-dom/test-utils';
import { expect } from 'chai';
import BuilderHeader from '../../builder-header';
import IconSettings from '../../icon-settings';
describe('SLDSBuilderHeader: ', function () {
  var clicked;

  var setClick = function setClick() {
    clicked = true;
  };

  var renderBuilderHeader = function renderBuilderHeader() {
    var ref = /*#__PURE__*/React.createRef();
    TestUtils.renderIntoDocument( /*#__PURE__*/React.createElement(IconSettings, {
      iconPath: "/assets/icons"
    }, /*#__PURE__*/React.createElement("div", {
      ref: ref
    }, /*#__PURE__*/React.createElement(BuilderHeader, {
      events: {
        onClickBack: setClick,
        onClickHelp: setClick
      }
    }))));
    return ReactDOM.findDOMNode(ref.current);
  };

  describe('Links are clickable', function () {
    var cmp;
    var links;
    beforeEach(function () {
      clicked = false;
      cmp = renderBuilderHeader();
      links = cmp.getElementsByClassName('slds-builder-header__item-action');
    });
    it('triggers when Back link is clicked', function () {
      expect(clicked).to.be.false;
      TestUtils.Simulate.click(links[0], {});
      expect(clicked).to.be.true;
    });
    it('triggers when Help link is clicked', function () {
      expect(clicked).to.be.false;
      TestUtils.Simulate.click(links[1], {});
      expect(clicked).to.be.true;
    });
  });
});
//# sourceMappingURL=builder-header.browser-test.js.map